class ClientTextures expands Mutator
	config(ChristmasSpawns);

// By: Age	

// Client-side texture changes.
	
// NOTE: Offline: Instant load, Online: Slow load.
#exec obj load file="MH\MH.u" package="Christmas"

var() EMusicTransition Transition; // Music transition.
var bool bDontCallMe;

struct TextureType
{
	var() config string TheLevel;
	var() config string TheTexture;
	var() config string TheLayerTexture;
	var() config bool TheLayerMode;
	var() config string By;
}; var() config array<TextureType> TextureLayer;

struct FakeTextureType
{
	var() string TheLevel;
	var() string TheTexture;
	var() string TheLayerTexture;
	var() bool TheLayerMode;
	var() string By;
}; var() array<FakeTextureType> FakeTextureLayer;

struct ClientTextureType
{
	var() string TheLevel;
	var() string TheTexture;
	var() string TheLayerTexture;
	var() bool TheLayerMode;
	var() string By;
}; var() array<ClientTextureType> ClientTextureLayer;

struct TextureSettingType
{
	var() config string TheLevel;
	var() config string TheTexture;
	var() config string TheProperty;
	var() config string TheValue;
	var() config string By;
}; var() config array<TextureSettingType> TextureSetting;

struct FakeTextureSettingType
{
	var() string TheLevel;
	var() string TheTexture;
	var() string TheProperty;
	var() string TheValue;
	var() string By;
}; var() array<FakeTextureSettingType> FakeTextureSetting;

struct ClientTextureSettingType
{
	var() string TheLevel;
	var() string TheTexture;
	var() string TheProperty;
	var() string TheValue;
	var() string By;
}; var() array<ClientTextureSettingType> ClientTextureSetting;

var() config float EffectTime;
var() config int TextureLoadMulti;
var() config int TextureSettingLoadMulti;
var() config float LoadRate;
var() config bool InstantLoadingChange;

var float Count;

var string MapNamed;

var int Limit1,Limit2,Limit3;

var int Num1,Num2,Num3;

var bool Do1,Do2,Do3;

var bool bOnce;

replication
{
	reliable if(role==role_authority)
		num1,num2,SetTextureArrayValue,SetTextureSettingArrayValue,SendTextureArrayLength,SendTextureSettingArrayLength,Tim1,Tim2,CallMe1,CallMe2;
}
simulated function PreBeginPlay()
{
	if( MapNamed=="" )
		MapNamed=Caps(string(Outer.Name));
}
simulated function SetTextureArrayValue(int Index, string Value1, string Value2, string Value3, bool Value4, string Value5) // Array props.
{
	if(Level.NetMode==NM_Client || Level.NetMode==NM_Standalone) // Saves bandwidth. Call this only for clients.
	{
		ClientTextureLayer[Index].TheLevel = Value1;
		ClientTextureLayer[Index].TheTexture = Value2;
		ClientTextureLayer[Index].TheLayerTexture = Value3;
		ClientTextureLayer[Index].TheLayerMode = Value4;
		ClientTextureLayer[Index].By = Value5;
	}
}
simulated function CallMe1(int Index) // Instant.
{
	local Texture FindTexture;
	local Texture T;
	local int Fake;
	
	Fake = GetArraySize(arrayproperty'ClientTextureLayer'); // ClientTextureLayer array size. *Should* remove scriptwarnings.
	if( MapNamed==ClientTextureLayer[Index].TheLevel ) // If map name matchs.
	{
		foreach allobjects(class'Texture',T) // Find all textures.
		{
			FindTexture=Texture(DynamicLoadObject(ClientTextureLayer[Index].TheTexture,class'Texture',true)); // Get the texture.
			if(T==FindTexture) // If texture matchs.
			{
				if(ClientTextureLayer[Index].TheLayerMode)
					T.MacroTexture = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Layer it.
				else
				{
					T.MacroTexture = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace it.
					T.DetailTexture = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace it.
					T.BumpMap = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace it.
					T.AnimCurrent = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace it.
					T.AnimNext = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace it.
					if(T.AnimNext!=None)
					{
						T.AnimNext.AnimNext = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace next texture next to previous.
						T.AnimNext.AnimCurrent = Texture(DynamicLoadObject(ClientTextureLayer[Index].TheLayerTexture,class'Texture')); // Replace next texture next to previous.
					}
					T.PrimeCount = 1;
					T.MinFrameRate = 0.000001; // As slow rate as possible.
					T.MaxFrameRate = 0.000001; // As slow rate as possible.
				}
			}
		}
	}
}
simulated function SetTextureSettingArrayValue(int Index, string Value1, string Value2, string Value3, string Value4, string Value5) // Array props.
{
	if(Level.NetMode==NM_Client || Level.NetMode==NM_Standalone) // Saves bandwidth. Call this only for clients.
	{
		ClientTextureSetting[Index].TheLevel = Value1;
		ClientTextureSetting[Index].TheTexture = Value2;
		ClientTextureSetting[Index].TheProperty = Value3;
		ClientTextureSetting[Index].TheValue = Value4;
		ClientTextureSetting[Index].By = Value5;
	}
}
simulated function CallMe2(int Index) // Instant.
{
	local Texture FindTexture;
	local Texture T;
	local MH MH2;
	local MH MH;
	local object oo;
	local class<actor> ooo;
	local class<actor> oooo;
	local int Fake;
	
	Fake = GetArraySize(arrayproperty'ClientTextureSetting'); // ClientTextureSetting array size. *Should* remove scriptwarnings.
	foreach allactors(class'MH',MH2)
	{
		if(MH2!=None)
			MH2.Destroy(); // Stop spawning millions of MH's.
	}
	MH = Spawn(class'MH');
	if(MH!=None)
		MH.bHidden = True;
	if( MapNamed==ClientTextureSetting[Index].TheLevel ) // If map name matchs.
	{
		foreach allobjects(class'Texture',T) // Find all textures.
		{
			FindTexture=Texture(DynamicLoadObject(ClientTextureSetting[Index].TheTexture,class'Texture',true)); // Get the texture.
			if(T==FindTexture)
			{
				oo=DynamicLoadObject(ClientTextureSetting[Index].TheValue,class'object',true); // Precache stuff.
				ooo=class<actor>(DynamicLoadObject(ClientTextureSetting[Index].TheValue,class'class',true)); // Precache stuff.
				oooo=class<actor>(DynamicLoadObject("unreali."$ClientTextureSetting[Index].TheValue,class'class',true)); // Precache stuff.
				T.SetPropertyText(ClientTextureSetting[Index].TheProperty,ClientTextureSetting[Index].TheValue); // Setup.
				if(caps(ClientTextureSetting[Index].TheProperty)=="DRAWSCALE")
					T.DrawScale = float(ClientTextureSetting[Index].TheValue);
				if(MH!=None)
					MH.DI(T,ClientTextureSetting[Index].TheProperty,ClientTextureSetting[Index].TheValue); // Hack.
			}
		}
	}
}
simulated function SendTextureArrayLength(int Count) // Set array lenght.
{
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return; // Saves bandwidth. Call this only for clients.
	InsertArrayIdx(ArrayProperty'ClientTextureLayer',0,Count);
}
simulated function SendTextureSettingArrayLength(int Count) // Set array lenght.
{
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return; // Saves bandwidth. Call this only for clients.
	InsertArrayIdx(ArrayProperty'ClientTextureSetting',0,Count);
}
function PostBeginPlay()
{
	SetTimer(EffectTime,false); // Effect time.
}
function Tick(float deltatime) // Load stuff.
{
	local int i;
	
	if(bDontCallMe) return;
	if( PlayerPawn(Owner)==None || PlayerPawn(Owner).Player==None ) // Stop if no owner.
	{
		Destroy();
		Return;
	}
	count+=deltatime;
	if(count>LoadRate)
	{
		if(Do1)
		{
			for(i=0;i<TextureLoadMulti;i++)
			{
				SetTextureArrayValue(num1,FakeTextureLayer[num1].TheLevel,FakeTextureLayer[num1].TheTexture,FakeTextureLayer[num1].TheLayerTexture,FakeTextureLayer[num1].TheLayerMode,FakeTextureLayer[num1].By);
				if(InstantLoadingChange) // Instant texture replace while loading.
					CallMe1(num1);
				if(Num1<Limit1)
					Num1+=1;
			}
			if(Num1>=Limit1 || Limit1<=0)
			{
				Do2=True;
				if(!InstantLoadingChange)
					Tim1(); // Replace textures.
				Do1=False;
			}
		}
		else if(Do2)
		{
			for(i=0;i<TextureSettingLoadMulti;i++)
			{
				SetTextureSettingArrayValue(num2,FakeTextureSetting[num2].TheLevel,FakeTextureSetting[num2].TheTexture,FakeTextureSetting[num2].TheProperty,FakeTextureSetting[num2].TheValue,FakeTextureSetting[num2].By);
				if(InstantLoadingChange) // Instant texture replace while loading.
					CallMe2(num2);
				if(Num2<Limit2)
					Num2+=1;
			}
			if(Num2>=Limit2 || Limit2<=0)
			{
				Do3=True;
				if(!InstantLoadingChange)
					Tim2(); // Set something to textures.
				Do2=False;
				LifeSpan = 2; // Die after 2 seconds.
			}
		}
		count=0;
	}
}
function Timer() // Reload stuff.
{	
	local int i,j;
	local int Huh;

	if(bDontCallMe) return;
	if( PlayerPawn(Owner)==None || PlayerPawn(Owner).Player==None ) // Stop if no owner.
	{
		Destroy();
		Return;
	}
	
	// Make "fake" stuff to protect config.
	for(i=0;i<GetArraySize(arrayproperty'TextureLayer');i++)
	{
		if(TextureLayer[i].TheLevel == MapNamed)
		{
			Huh = GetArraySize(arrayproperty'FakeTextureLayer'); // FakeTextureLayer array size.
			FakeTextureLayer[Huh].TheLevel = TextureLayer[i].TheLevel;
			FakeTextureLayer[Huh].TheTexture = TextureLayer[i].TheTexture;
			FakeTextureLayer[Huh].TheLayerTexture = TextureLayer[i].TheLayerTexture;
			FakeTextureLayer[Huh].TheLayerMode = TextureLayer[i].TheLayerMode;
			FakeTextureLayer[Huh].By = TextureLayer[i].By;
		}
	}
	
	for(i=0;i<GetArraySize(arrayproperty'TextureSetting');i++)
	{
		if(TextureSetting[i].TheLevel == MapNamed)
		{
			Huh = GetArraySize(arrayproperty'FakeTextureSetting'); // FakeTextureSetting array size.
			FakeTextureSetting[Huh].TheLevel = TextureSetting[i].TheLevel;
			FakeTextureSetting[Huh].TheTexture = TextureSetting[i].TheTexture;
			FakeTextureSetting[Huh].TheProperty = TextureSetting[i].TheProperty;
			FakeTextureSetting[Huh].TheValue = TextureSetting[i].TheValue;
			FakeTextureSetting[Huh].By = TextureSetting[i].By;
		}
	}

	
	if(LoadRate>0) // Load.
	{
		Do1=True;
		Do2=True;
	}
	
	SendTextureArrayLength(GetArraySize(arrayproperty'FakeTextureLayer')); // FakeTextureLayer array size.
	Limit1=GetArraySize(arrayproperty'FakeTextureLayer');
	SendTextureSettingArrayLength(GetArraySize(arrayproperty'FakeTextureSetting')); // FakeTextureSetting array size.
	Limit2=GetArraySize(arrayproperty'FakeTextureSetting');
	
	if(LoadRate<0 || Level.NetMode == NM_StandAlone) // Instant.
	{
		J = GetArraySize(arrayproperty'FakeTextureLayer'); // TextureLayer array size.
		for( i=0; i<j; i++ )
			SetTextureArrayValue(i,FakeTextureLayer[i].TheLevel,FakeTextureLayer[i].TheTexture,FakeTextureLayer[i].TheLayerTexture,FakeTextureLayer[i].TheLayerMode,FakeTextureLayer[i].By);
		Tim1();
		J = GetArraySize(arrayproperty'FakeTextureSetting'); // TextureSetting array size.
		for( i=0; i<j; i++ )
			SetTextureSettingArrayValue(i,FakeTextureSetting[i].TheLevel,FakeTextureSetting[i].TheTexture,FakeTextureSetting[i].TheProperty,FakeTextureSetting[i].TheValue,FakeTextureSetting[i].By);
		Tim2();
	}
}
simulated function Tim1()
{
	local int lv,lva;
	local Texture FindTexture;
	local Texture T;
	
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return; // Saves bandwidth. Call this only for clients.
	lva = GetArraySize(ArrayProperty'ClientTextureLayer'); // ClientTextureLayer array size.
	for(lv=0;lv<lva;lv++)
	{
		if( MapNamed==ClientTextureLayer[lv].TheLevel ) // If map name matchs.
		{
			foreach allobjects(class'Texture',T) // Find all textures.
			{
				if(T!=None)
				{
					FindTexture=Texture(DynamicLoadObject(ClientTextureLayer[lv].TheTexture,class'Texture',true)); // Get the texture.
					if(T==FindTexture) // If texture matchs.
					{
						if(ClientTextureLayer[lv].TheLayerMode)
							T.MacroTexture = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Layer it.
						else
						{
							T.MacroTexture = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
							T.DetailTexture = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
							T.BumpMap = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
							T.AnimCurrent = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
							T.AnimNext = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
							if(T.AnimNext!=None)
							{
								T.AnimNext.AnimNext = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
								T.AnimNext.AnimCurrent = Texture(DynamicLoadObject(ClientTextureLayer[lv].TheLayerTexture,class'Texture')); // Replace it.
							}
							T.PrimeCount = 1;
							T.MinFrameRate = 0.000001; // As slow rate as possible.
							T.MaxFrameRate = 0.000001; // As slow rate as possible.
						}
					}
				}
			}
		}
	}
}
simulated function Tim2()
{
	local int iv,iva;
	local Texture FindTexture;
	local Texture T;
	local MH MH2;
	local MH MH;
	local object oo;
	local class<actor> ooo;
	local class<actor> oooo;
	
	if(Level.NetMode!=NM_Client && Level.NetMode!=NM_Standalone) return; // Saves bandwidth. Call this only for clients.
	foreach allactors(class'MH',MH2)
	{
		if(MH2!=None)
			MH2.Destroy(); // Stop spawning millions of MH's.
	}
	MH = Spawn(class'MH');
	if(MH!=None)
		MH.bHidden = True;
	iva = GetArraySize(ArrayProperty'ClientTextureSetting'); // ClientTextureSetting array size.
	for(iv=0;iv<iva;iv++) // Texture properties
	{
		if( MapNamed==ClientTextureSetting[iv].TheLevel ) // If map name matchs.
		{
			foreach allobjects(class'Texture',T) // Find all textures.
			{
				if(T!=None)
				{
					FindTexture=Texture(DynamicLoadObject(ClientTextureSetting[iv].TheTexture,class'Texture',true)); // Get the texture.
					if(T==FindTexture) // If texture mathcs.
					{
						oo=DynamicLoadObject(ClientTextureSetting[iv].TheValue,class'object',true); // Precache stuff.
						ooo=class<actor>(DynamicLoadObject(ClientTextureSetting[iv].TheValue,class'class',true)); // Precache stuff.
						oooo=class<actor>(DynamicLoadObject("unreali."$ClientTextureSetting[iv].TheValue,class'class',true)); // Precache stuff.
						T.SetPropertyText(ClientTextureSetting[iv].TheProperty,ClientTextureSetting[iv].TheValue); // Setup.
						if(caps(ClientTextureSetting[iv].TheProperty)=="DRAWSCALE")
							T.DrawScale = float(ClientTextureSetting[iv].TheValue);
						if(MH!=None)
							MH.DI(T,ClientTextureSetting[iv].TheProperty,ClientTextureSetting[iv].TheValue); // Hack. Force const values like bx3 (=mirror).
					}
				}
			}
		}
	}
}

defaultproperties
{
				RemoteRole=ROLE_SimulatedProxy
				DrawScale=0.000000
}
